﻿using JPK_VDEK.Core;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace JPK_VDEK
{
    public static class JpkData
    {
        static private JpkExt aJpk;

        public static JPK getBaseJpk()
        {
            JPK jpk = new JPK();
            jpk.Naglowek = aJpk.Naglowek;
            jpk.Podmiot1 = aJpk.Podmiot1;
            jpk.Deklaracja = aJpk.Deklaracja;
            jpk.SprzedazWiersz = aJpk.SprzedazWiersz;
            jpk.SprzedazCtrl = aJpk.SprzedazCtrl;
            jpk.ZakupWiersz = aJpk.ZakupWiersz;
            jpk.ZakupCtrl = aJpk.ZakupCtrl;
            return jpk;
        }
        public static JpkExt getJpk()
        {
            if(aJpk==null)
            {
                JpkData.initJpk();
            }
            return aJpk;
        }
        public static void initJpk()
        {
            aJpk = new JpkExt();

            aJpk.wczytalemGL = false;

            aJpk.Naglowek = new JPKNaglowek();
            aJpk.Naglowek.KodFormularza = new TNaglowekKodFormularza();
            aJpk.Naglowek.CelZlozenia = new TNaglowekCelZlozenia();
            aJpk.Naglowek.KodFormularzaDekl = new TNaglowekKodFormularzaDekl();
            aJpk.Naglowek.WariantFormularzaDekl = 21;
            aJpk.Naglowek.WariantFormularza = 1;

            aJpk.Podmiot1 = new JPKPodmiot1();

            aJpk.Deklaracja = new JPKDeklaracja();

            aJpk.SprzedazWiersz = new List<JPKSprzedazWiersz>();

            aJpk.SprzedazCtrl = new JPKSprzedazCtrl();

            aJpk.ZakupWiersz = new List<JPKZakupWiersz>();

            aJpk.ZakupCtrl = new JPKZakupCtrl();
            aJpk.ViewSP = new ObservableCollection<JPKSprzedazWierszExt>();
            aJpk.ViewZA = new ObservableCollection<JPKZakupWiersz>();

            aJpk.Sumy = new JPKSumyKontrola();

            aJpk.Cel = new TCels();
            aJpk.Urz = new US();
        }
    }
    public class JJPKZakupWierszExt: JPKZakupWiersz
    {
        public string TypDokumentuExt { get; set; }
        public JJPKZakupWierszExt()
        {
            TypDokumentuExt = "";
        }
        public void CopyFromBase(JPKZakupWiersz a)
        {
            LpZakupu = a.LpZakupu;
            DowodZakupu = a.DowodZakupu;
            NazwaDostawcy = a.NazwaDostawcy;
            NrDostawcy = a.NrDostawcy;
            DataWplywu = a.DataWplywu;
            DataZakupu = a.DataZakupu;
            K_40 = a.K_40;
            K_41 = a.K_41;
            K_42 = a.K_42;
            K_43 = a.K_43;
            K_44 = a.K_44;
            K_45 = a.K_45;
            K_46 = a.K_46;
            K_47 = a.K_47;
            KodKrajuNadaniaTIN = a.KodKrajuNadaniaTIN;
            DokumentZakupu = a.DokumentZakupu;
            MPP = a.MPP;
            IMP = a.IMP;
            ZakupVAT_Marza = a.ZakupVAT_Marza;
         
        }

    }
    public class JPKSprzedazWierszExt : JPKSprzedazWiersz
    {
        public string TypDokumentuExt { get; set; }

        public JPKSprzedazWierszExt()
        {
            TypDokumentuExt = "";
        }
        public void CopyFromBase(JPKSprzedazWiersz a)
        {
            LpSprzedazy = a.LpSprzedazy;
            DataSprzedazy = a.DataSprzedazy;
            DataWystawienia = a.DataWystawienia;
            DowodSprzedazy = a.DowodSprzedazy;
            NazwaKontrahenta = a.NazwaKontrahenta;
            K_10 = a.K_10;
            K_11 = a.K_11;
            K_12 = a.K_12;
            K_13 = a.K_13;
            K_14 = a.K_14;
            K_15 = a.K_15;
            K_16 = a.K_16;
            K_17 = a.K_17;
            K_18 = a.K_18;
            K_19 = a.K_19;
            K_20 = a.K_20;
            K_21 = a.K_21;
            K_22 = a.K_22;
            K_23 = a.K_23;
            K_24 = a.K_24;
            K_25 = a.K_25;
            K_26 = a.K_26;
            K_27 = a.K_27;
            K_28 = a.K_28;
            K_29 = a.K_29;
            K_30 = a.K_30;
            K_31 = a.K_31;
            K_32 = a.K_32;
            K_33 = a.K_33;
            K_34 = a.K_34;
            K_35 = a.K_35;
            K_36 = a.K_36;
            SprzedazVAT_Marza = a.SprzedazVAT_Marza;
            NrKontrahenta = a.NrKontrahenta;
            KodKrajuNadaniaTIN = a.KodKrajuNadaniaTIN;
            TypDokumentu = a.TypDokumentu;
            GTU_01 = a.GTU_01;
            GTU_02 = a.GTU_02;
            GTU_03 = a.GTU_03;
            GTU_04 = a.GTU_04;
            GTU_05 = a.GTU_05;
            GTU_06 = a.GTU_06;
            GTU_07 = a.GTU_07;
            GTU_08 = a.GTU_08;
            GTU_09 = a.GTU_09;
            GTU_10 = a.GTU_10;
            GTU_11 = a.GTU_11;
            GTU_12 = a.GTU_12;
            GTU_13 = a.GTU_13;
            SW = a.SW;
            EE = a.EE;
            TP = a.TP;
            TT_WNT = a.TT_WNT;
            TT_D = a.TT_D;
            MR_T = a.MR_T;
            MR_UZ = a.MR_UZ;
            I_42 = a.I_42;
            I_63 = a.I_63;
            B_SPV = a.B_SPV;
            B_SPV_DOSTAWA = a.B_SPV_DOSTAWA;
            B_MPV_PROWIZJA = a.B_MPV_PROWIZJA;
            MPP = a.MPP;
            KorektaPodstawyOpodt = a.KorektaPodstawyOpodt;

        }

    }
    public class JpkExt : JPK , INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged( String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
        public void setCel(int poz)
        {
            this.Naglowek.CelZlozenia.Value = Convert.ToSByte(this.Cel.Cel[poz].Key);
            NotifyPropertyChanged();
        }
        public void setUrzad(int poz)
        {
            string kod = this.Urz.Lista[poz].Kod;
            if(kod.Equals("0271"))
            {
                this.Naglowek.KodUrzedu = TKodUS.Item0271;
                this.UsNazwa = this.Urz.Lista[poz].Describe;
            }
            if (kod.Equals("0225"))
            {
                this.Naglowek.KodUrzedu = TKodUS.Item0225;
                this.UsNazwa = this.Urz.Lista[poz].Describe;
            }
            NotifyPropertyChanged();
        }
        private Decimal p39;
        public Decimal P39 {
            get 
            {
                return p39;
            }
            set
                {
                p39 = value;
                this.Deklaracja.PozycjeSzczegolowe.P_39 = P39.ToString();
                    NotifyPropertyChanged();
                }
             }
        public ObservableCollection<JPKSprzedazWierszExt> ViewSP { get; set; }
        public ObservableCollection<JPKZakupWiersz> ViewZA { get; set; }

        public JPKSumyKontrola Sumy { get; set; }
        public string outScalony { get; set; }
        public string  UsNazwa { get; set; }
        public bool P55 { get; set; }
        public bool P56 { get; set; }
        public bool P57 { get; set; }
        public bool P58 { get; set; }
        public bool P59 { get; set; }
        public bool P63 { get; set; }
        public bool P64 { get; set; }
        public bool P65 { get; set; }
        public bool P66 { get; set; }
        public bool P67 { get; set; }
        public TCels Cel { get; set; }
        public US Urz { get; set; }
        public bool wczytalemGL { get; set; }
    }
}
